<template>
  <!-- 随访调查 -->
  <div class="screeningSearch">
    <div class="top">
      <form-components :forms="formList" @handleSearch="onSearch"></form-components>
    </div>
    <div class="bot">
      <customs-table
        ref="table"
        :table-data="tableData"
        :columns="columns"
        :header-class="'newHeader'"
        :list-loading="listLoading"
        :current-page="pageIndex"
        :total-count="total"
        :page-sizes="pageSizes"
        :page-size="pageSize"
        @pageSizeChange="handleSizeChange"
        @currentPageChange="handleCurrentChange"
      />
    </div>
  </div>
</template>
<script>
import FormComponents from "@/components/FormComponents"
import CustomsTable from "@/components/CustomsTable"
import paginationMixin from "@/components/TabComponents/mixin"
import { getFollowSurvey } from "@/api/followup"
import { getDictDetail } from "@/api/dict.js"
export default {
  components: {
    CustomsTable,
    FormComponents,
  },
  mixins: [paginationMixin],
  data() {
    return {
      listLoading: false,
      keyword: "",
      modifiedFlag: false,
      columns: [
        {
          label: "医联体",
          value: "unionName",
          minWidth: 120,
        },
        {
          label: "姓名",
          value: "name",
          minWidth: 120,
        },
        {
          label: "性别",
          value: "sex",
          minWidth: 120,
          // trans:'d-sex',
          transList:{
            1:'男',
            2:'女'
          }
        },
        {
          label: "身份证",
          value: "idCard",
          minWidth: 120,
        },
        {
          label: "年龄",
          value:"age",
          minWidth: 120,
        },
        {
          label: "筛查时间",
          value: "screeningTime",
          minWidth: 120,
        },
        {
          label: "风险评估结果",
          value: "riskRank",
          trans:'risk_level',
          transList:{
          },
          minWidth: 120,
        },
        {
          label: "上次随访时间",
          value: "followTime",
          minWidth: 120,
        },
        {
          label: "随访进度",
          value: "followBatch",
          trans:'follow_type',
          transList:{
          },
          minWidth: 120,
        },
        {
          label: "计划随访时间",
          value: "nextFollowTime",
          trans:'next_follow_time',
          minWidth: 120,
        },
        {
          label: "操作",
          width: 220,
          fixed: "right",
          operType: "button",
          operations: [
            {
              func: this.rowOpration,
              formatter(row) {
                return {
                  label: " 录入",
                  type: "text",
                }
              },
            },
          ],
        },
      ],
      tableData: [],
      formList: [
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "select",
          label: "计划随访时间",
          prop: "nextFollowTime",
          trans:'next_follow_time',
          placeholder: "请选择计划随访时间",
          rules: [],
          opts: [{ label: "123", value: "1" }],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "input",
          label: "姓名",
          prop: "name",
          placeholder: "请输入姓名",
          rules: [],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "input",
          label: "身份证",
          prop: "idCard",
          placeholder: "请输入身份证",
          rules: [],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "input",
          label: "医联体",
          prop: "unionName",
          placeholder: "请输入医联体",
          rules: [],
        },
        {
          xs: 24,
          sm: 12,
          md: 12,
          lg: 7,
          xl: 7,
          type: "select",
          label: "随访进度",
          prop: "followBatch",
          trans:'follow_type',
          placeholder: "请选择随访进度",
          rules: [],
          opts: [{ label: "123", value: "1" }],
        },
        {
          xs: 1,
          sm: 2,
          md: 2,
          lg: 2,
          xl: 2,
          type: "btn",
          list: [
            {
              btnType: "button",
              type: "",
              style: {
                width: "80px",
                height: "32px",
                borderRadius: "4px",
                fontSize: "14px",
                marginLeft: "40px",
              },
              btnText: "查询",
              func: this.onSearch
            },
            // {
            //   btnType: "tobeModified",
            //   tobeModified: 20,
            // },
          ],
        },
      ],
      // pageSize:1,
      // pageNum:10,
      // totalCount:20
    }
  },
  watch: {},
  created(){
    this.initColumn()
  },
  mounted() {
    this.handleSearch()
  },
  methods: {
    changeModified() {
      this.modifiedFlag = !this.modifiedFlag
    },
    setSelectedIndex(i) {
      console.log(this.selectedIndex)
      this.selectedIndex = i
      sessionStorage.setItem("homeSelectedIndex", this.selectedIndex)
    },
    changePage(v) {
      this.page[v.type] = v.value
      console.log(this.page)
      this.$refs.customTable.loading = false
    },
    onSearch(form) {
      console.log(form)
    },
    rowOpration(data, i) {
      console.log(data, i)
      this.$router.push("/followupentry")
    },
    async handleSearch(){
      let params={
        pageSize:this.pageSize,
        pageNum:this.pageIndex
      }
      let res = await getFollowSurvey(params)
      if(res.code==1){
        //分页内容
        const d = res.data
        this.total= d.total
        this.tableData=d['records']
      }
    },
    initColumn(){
      this.columns.forEach((item,index) => {
        if(item.trans){
          this.initDict(item.trans,index)
        }
      })
    },
    async initDict(type,index){
      let params={
        type:type
      }
      const res = await getDictDetail(params)
      let item = this.formList.find(_ => _.trans == type)
      res.data.forEach((itemD,inx) => {
        if(!this.columns[index]['transList']){
           this.columns[index]['transList']={}
        }
        else{
          this.columns[index]['transList'][itemD.code]=itemD.name
        }
        if(item){
          if(!item['opts']){
           item['opts']=[]
        }
        else {
            item['opts']=res.data.map((_) => {
              return {
                label: _.name,
                value: _.code,
              }
            })
          }
        }
      })
    }
  },
}
</script>
<style lang="scss" scoped>
.screeningSearch {
  .top {
    width: 100%;
    // height: 72px;
    padding: 0 116px 0 44px;
    display: flex;
    justify-content: space-between;
    align-items: center;
  }
  .bot {
    padding: 0 24px;
  }
}
</style>
